// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { LogError } from "../../../../core/decorator/LogErrorDecorator";
import { GetAccountBalanceRequest } from "../../request";
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import { BalanceOfQuery } from "../../../../app/usecase/query/security/balanceof/BalanceOfQuery";
import { BaseSecurityInPort } from "../BaseSecurityInPort";
export class SecurityInPortBalance extends BaseSecurityInPort {
    async getBalanceOf(request) {
        ValidatedRequest.handleValidation("GetAccountBalanceRequest", request);
        const res = await this.queryBus.execute(new BalanceOfQuery(request.securityId, request.targetId));
        const balance = { value: res.payload.toString() };
        return balance;
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GetAccountBalanceRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortBalance.prototype, "getBalanceOf", null);
